package com.fjhx.xmhjc.controller.column;

import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.column.vo.ColumnArticleVo;
import com.fjhx.xmhjc.entity.column.dto.ColumnArticleSelectDto;
import com.fjhx.xmhjc.entity.column.dto.ColumnArticleDto;
import com.ruoyi.common.core.domain.BaseSelectDto;
import com.fjhx.xmhjc.service.column.ColumnArticleService;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * <p>
 * 栏目文章表 前端控制器
 * </p>
 *
 * @author lqh
 * @since 2023-11-16
 */
@RestController
@RequestMapping("/columnArticle")
public class ColumnArticleController {

    @Autowired
    private ColumnArticleService columnArticleService;

    /**
     * 栏目文章表列表
     */
    @PostMapping("/list")
    public List<ColumnArticleVo> list(@RequestBody ColumnArticleSelectDto dto) {
        return columnArticleService.getList(dto);
    }

    /**
     * 栏目文章表分页
     */
    @PostMapping("/page")
    public Page<ColumnArticleVo> page(@RequestBody ColumnArticleSelectDto dto) {
        return columnArticleService.getPage(dto);
    }

    /**
     * 栏目文章表明细
     */
    @PostMapping("/detail")
    public ColumnArticleVo detail(@RequestBody BaseSelectDto dto) {
        return columnArticleService.detail(dto.getId());
    }

    /**
     * 栏目文章表新增
     */
    @PostMapping("/add")
    public void add(@RequestBody ColumnArticleDto columnArticleDto) {
        columnArticleService.add(columnArticleDto);
    }

    /**
     * 栏目文章表编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody ColumnArticleDto columnArticleDto) {
        columnArticleService.edit(columnArticleDto);
    }

    /**
     * 栏目文章表删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        columnArticleService.delete(dto.getId());
    }

}
