package com.fjhx.xmhjc.controller.column;

import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.column.vo.ColumnMenuVo;
import com.fjhx.xmhjc.entity.column.dto.ColumnMenuSelectDto;
import com.fjhx.xmhjc.entity.column.dto.ColumnMenuDto;
import com.ruoyi.common.core.domain.BaseSelectDto;
import com.fjhx.xmhjc.service.column.ColumnMenuService;
import org.springframework.beans.factory.annotation.Autowired;


/**
 * 栏目菜单表 前端控制器
 *
 * @author lqh
 * @since 2023-11-15
 */
@RestController
@RequestMapping("/columnMenu")
public class ColumnMenuController {

    @Autowired
    private ColumnMenuService columnMenuService;

    /**
     * 栏目菜单表分页
     */
    @PostMapping("/page")
    public Page<ColumnMenuVo> page(@RequestBody ColumnMenuSelectDto dto) {
        return columnMenuService.getPage(dto);
    }

    /**
     * 栏目菜单表明细
     */
    @PostMapping("/detail")
    public ColumnMenuVo detail(@RequestBody BaseSelectDto dto) {
        return columnMenuService.detail(dto.getId());
    }

    /**
     * 栏目菜单表新增
     */
    @PostMapping("/add")
    public void add(@RequestBody ColumnMenuDto columnMenuDto) {
        columnMenuService.add(columnMenuDto);
    }

    /**
     * 栏目菜单表编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody ColumnMenuDto columnMenuDto) {
        columnMenuService.edit(columnMenuDto);
    }

    /**
     * 栏目菜单表删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        columnMenuService.delete(dto.getId());
    }

}
