package com.fjhx.xmhjc.controller.column;

import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.column.vo.ColumnMenuSubVo;
import com.fjhx.xmhjc.entity.column.dto.ColumnMenuSubSelectDto;
import com.fjhx.xmhjc.entity.column.dto.ColumnMenuSubDto;
import com.ruoyi.common.core.domain.BaseSelectDto;
import com.fjhx.xmhjc.service.column.ColumnMenuSubService;
import org.springframework.beans.factory.annotation.Autowired;


/**
 * 栏目-子栏目 前端控制器
 *
 * @author lqh
 * @since 2023-11-15
 */
@RestController
@RequestMapping("/columnMenuSub")
public class ColumnMenuSubController {

    @Autowired
    private ColumnMenuSubService columnMenuSubService;

    /**
     * 栏目-子栏目分页
     */
    @PostMapping("/page")
    public Page<ColumnMenuSubVo> page(@RequestBody ColumnMenuSubSelectDto dto) {
        return columnMenuSubService.getPage(dto);
    }

    /**
     * 栏目-子栏目明细
     */
    @PostMapping("/detail")
    public ColumnMenuSubVo detail(@RequestBody BaseSelectDto dto) {
        return columnMenuSubService.detail(dto.getId());
    }

    /**
     * 栏目-子栏目新增
     */
    @PostMapping("/add")
    public void add(@RequestBody ColumnMenuSubDto columnMenuSubDto) {
        columnMenuSubService.add(columnMenuSubDto);
    }

    /**
     * 栏目-子栏目编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody ColumnMenuSubDto columnMenuSubDto) {
        columnMenuSubService.edit(columnMenuSubDto);
    }

    /**
     * 栏目-子栏目删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        columnMenuSubService.delete(dto.getId());
    }

}
