package com.fjhx.xmhjc.service.column.impl;

import com.fjhx.file.utils.ObsFileUtil;
import com.fjhx.xmhjc.entity.about.po.AboutUsCulture;
import com.fjhx.xmhjc.entity.column.po.ColumnArticle;
import com.fjhx.xmhjc.mapper.column.ColumnArticleMapper;
import com.fjhx.xmhjc.service.column.ColumnArticleService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.wrapper.SqlField;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.column.vo.ColumnArticleVo;
import com.fjhx.xmhjc.entity.column.dto.ColumnArticleSelectDto;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.fjhx.xmhjc.entity.column.dto.ColumnArticleDto;
import cn.hutool.core.bean.BeanUtil;

import java.util.List;

/**
 * <p>
 * 栏目文章表 服务实现类
 * </p>
 *
 * @author lqh
 * @since 2023-11-16
 */
@Service
public class ColumnArticleServiceImpl extends ServiceImpl<ColumnArticleMapper, ColumnArticle> implements ColumnArticleService {

    @Override
    public List<ColumnArticleVo> getList(ColumnArticleSelectDto dto) {
        IWrapper<ColumnArticle> wrapper = getWrapper();
        wrapper.keyword(dto, new SqlField("ca", ColumnArticle::getSort));
        wrapper.orderByAsc("ca", ColumnArticle::getSort);
        List<ColumnArticleVo> list = this.baseMapper.getList(wrapper);
        return list;
    }

    @Override
    public Page<ColumnArticleVo> getPage(ColumnArticleSelectDto dto) {
        IWrapper<ColumnArticle> wrapper = getWrapper();
        wrapper.orderByDesc("ca", ColumnArticle::getId);
        Page<ColumnArticleVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public ColumnArticleVo detail(Long id) {
        ColumnArticle ColumnArticle = this.getById(id);
        ColumnArticleVo result = BeanUtil.toBean(ColumnArticle, ColumnArticleVo.class);
        return result;
    }

    @Override
    public void add(ColumnArticleDto columnArticleDto) {
        this.save(columnArticleDto);

        // 封面
        ObsFileUtil.saveFile(columnArticleDto.getCoverList(), columnArticleDto.getId(), 1);
        ObsFileUtil.saveFile(columnArticleDto.getVideoList(), columnArticleDto.getId(), 2);
    }

    @Override
    public void edit(ColumnArticleDto columnArticleDto) {
        this.updateById(columnArticleDto);

        // 封面
        ObsFileUtil.editFile(columnArticleDto.getCoverList(), columnArticleDto.getId(), 1);
        ObsFileUtil.editFile(columnArticleDto.getVideoList(), columnArticleDto.getId(), 2);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
