package com.fjhx.xmhjc.service.column.impl;

import com.fjhx.xmhjc.entity.about.po.AboutUsCulture;
import com.fjhx.xmhjc.entity.column.dto.ColumnMenuSubSelectDto;
import com.fjhx.xmhjc.entity.column.po.ColumnMenu;
import com.fjhx.xmhjc.entity.column.vo.ColumnMenuSubVo;
import com.fjhx.xmhjc.mapper.column.ColumnMenuMapper;
import com.fjhx.xmhjc.service.column.ColumnMenuService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.DictUtils;
import com.ruoyi.common.utils.wrapper.SqlField;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.column.vo.ColumnMenuVo;
import com.fjhx.xmhjc.entity.column.dto.ColumnMenuSelectDto;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.fjhx.xmhjc.entity.column.dto.ColumnMenuDto;
import cn.hutool.core.bean.BeanUtil;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;


/**
 * <p>
 * 栏目菜单表 服务实现类
 * </p>
 *
 * @author lqh
 * @since 2023-11-15
 */
@Service
public class ColumnMenuServiceImpl extends ServiceImpl<ColumnMenuMapper, ColumnMenu> implements ColumnMenuService {

    @Resource
    private ColumnMenuSubServiceImpl columnMenuSubService;


    @Override
    public Page<ColumnMenuVo> getPage(ColumnMenuSelectDto dto) {
        IWrapper<ColumnMenu> wrapper = getWrapper();
        wrapper.keyword(dto,new SqlField("cm", ColumnMenu::getName));
        wrapper.orderByAsc("cm", ColumnMenu::getSort);
        Page<ColumnMenuVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public ColumnMenuVo detail(Long id) {
        ColumnMenu ColumnMenu = this.getById(id);
        ColumnMenuVo result = BeanUtil.toBean(ColumnMenu, ColumnMenuVo.class);

        ColumnMenuSubSelectDto columnMenuSubSelectDto = new ColumnMenuSubSelectDto();
        columnMenuSubSelectDto.setColumnId(id);
        List<ColumnMenuSubVo> list = columnMenuSubService.getList(columnMenuSubSelectDto);
        result.setColumnMenuSubList(list);

        return result;
    }

    @Override
    @Transactional
    public void add(ColumnMenuDto columnMenuDto) {
        this.save(columnMenuDto);
        //处理子表
        columnMenuSubService.handleColumnMenuSub(columnMenuDto.getId(),columnMenuDto.getColumnMenuSubList());
    }

    @Override
    public void edit(ColumnMenuDto columnMenuDto) {
        this.updateById(columnMenuDto);
        //处理子表
        columnMenuSubService.handleColumnMenuSub(columnMenuDto.getId(),columnMenuDto.getColumnMenuSubList());
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);

        //TODO判断菜单及栏目是否有文章


    }

}
