package com.fjhx.xmhjc.service.product;

import com.fjhx.xmhjc.entity.product.po.ProductCategory;
import com.fjhx.xmhjc.entity.product.po.ProductSubCategory;
import com.ruoyi.common.core.service.BaseService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.product.vo.ProductSubCategoryVo;
import com.fjhx.xmhjc.entity.product.dto.ProductSubCategorySelectDto;
import com.fjhx.xmhjc.entity.product.dto.ProductSubCategoryDto;

import java.util.List;


/**
 * <p>
 * 产品类目表 服务类
 * </p>
 *
 * @author hj
 * @since 2023-11-16
 */
public interface ProductSubCategoryService extends BaseService<ProductSubCategory> {

    /**
     * 产品类目表分页
     */
    Page<ProductSubCategoryVo> getPage(ProductSubCategorySelectDto dto);

    /**
     * 产品类目表明细
     */
    ProductSubCategoryVo detail(Long id);

    /**
     * 产品类目表新增
     */
    void add(ProductSubCategoryDto productSubCategoryDto);

    /**
     * 产品类目表编辑
     */
    void edit(ProductSubCategoryDto productSubCategoryDto);

    /**
     * 产品类目表删除
     */
    void delete(Long id);

    List<ProductSubCategory> listByParentId(Long id);

    void deleteByParentId(Long parentId);

    void dealSubCategory(Long id, List<ProductSubCategory> subCategoryList);
}
