package com.fjhx.xmhjc.service.product.impl;

import com.fjhx.xmhjc.entity.product.po.ProductCategory;
import com.fjhx.xmhjc.entity.product.po.ProductSubCategory;
import com.fjhx.xmhjc.entity.product.vo.ProductCategoryVo;
import com.fjhx.xmhjc.mapper.product.ProductSubCategoryMapper;
import com.fjhx.xmhjc.service.product.ProductSubCategoryService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.product.vo.ProductSubCategoryVo;
import com.fjhx.xmhjc.entity.product.dto.ProductSubCategorySelectDto;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.fjhx.xmhjc.entity.product.dto.ProductSubCategoryDto;
import cn.hutool.core.bean.BeanUtil;

import java.util.List;


/**
 * <p>
 * 产品类目表 服务实现类
 * </p>
 *
 * @author hj
 * @since 2023-11-16
 */
@Service
public class ProductSubCategoryServiceImpl extends ServiceImpl<ProductSubCategoryMapper, ProductSubCategory> implements ProductSubCategoryService {

    @Override
    public Page<ProductSubCategoryVo> getPage(ProductSubCategorySelectDto dto) {
        IWrapper<ProductSubCategory> wrapper = getWrapper();
        wrapper.orderByDesc("psc", ProductSubCategory::getId);
        Page<ProductSubCategoryVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public ProductSubCategoryVo detail(Long id) {
        ProductSubCategory ProductSubCategory = this.getById(id);
        ProductSubCategoryVo result = BeanUtil.toBean(ProductSubCategory, ProductSubCategoryVo.class);
        return result;
    }

    @Override
    public void add(ProductSubCategoryDto productSubCategoryDto) {
        this.save(productSubCategoryDto);
    }

    @Override
    public void edit(ProductSubCategoryDto productSubCategoryDto) {
        this.updateById(productSubCategoryDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

    @Override
    public List<ProductSubCategory> listByParentId(Long id) {
        List<ProductSubCategory> list = this.lambdaQuery().eq(ProductSubCategory::getParentId, id).orderByAsc(ProductSubCategory::getSort).list();
        return list;
    }

    @Override
    public void deleteByParentId(Long parentId) {
        this.baseMapper.deleteByParentId(parentId);
    }

    @Override
    public void dealSubCategory(Long parentId, List<ProductSubCategory> subCategoryList) {
        this.deleteByParentId(parentId);
        subCategoryList.forEach(item -> item.setParentId(parentId));
        saveBatch(subCategoryList);
    }
}
