package com.fjhx.xmhjc.service.website;

import com.fjhx.xmhjc.entity.website.po.WebsiteUsers;
import com.ruoyi.common.core.service.BaseService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.website.vo.WebsiteUsersVo;
import com.fjhx.xmhjc.entity.website.dto.WebsiteUsersSelectDto;
import com.fjhx.xmhjc.entity.website.dto.WebsiteUsersDto;

import java.util.List;
import java.util.Optional;

/**
 * <p>
 * 首页用户 服务类
 * </p>
 *
 * @author hj
 * @since 2023-11-17
 */
public interface WebsiteUsersService extends BaseService<WebsiteUsers> {

    /**
     * 首页用户列表
     */
    List<WebsiteUsersVo> getList(WebsiteUsersSelectDto dto);

    /**
     * 首页用户分页
     */
    Page<WebsiteUsersVo> getPage(WebsiteUsersSelectDto dto);

    /**
     * 首页用户明细
     */
    WebsiteUsersVo detail(Long id);

    /**
     * 首页用户新增
     */
    void add(WebsiteUsersDto websiteUsersDto);

    /**
     * 首页用户编辑
     */
    void edit(WebsiteUsersDto websiteUsersDto);

    /**
     * 首页用户删除
     */
    void delete(Long id);

    /**
     * 注册用户
     * @author hj
     * @date 2023/11/17 9:43
     * @param websiteUsersDto 
     */
    void register(WebsiteUsersDto websiteUsersDto);

    Optional<WebsiteUsers> getByUserName(String userName);
}
